#include "ginycanvibase.h"
#include "ui_ginycanvibase.h"

GinyCanviBase::GinyCanviBase(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::GinyCanviBase)
{
    ui->setupUi(this);
    connect(ui->leHex,SIGNAL(textChanged(QString)),
            this,SLOT(on_leHex_textChanged(QString)));
    connect(ui->leBin,SIGNAL(textChanged(QString)),
            this,SLOT(on_leBin_textChanged(QString)));
}

GinyCanviBase::~GinyCanviBase()
{
    delete ui;
}


void GinyCanviBase::on_leDec_textChanged(const QString &arg1)
{
    bool bOk;

    int n = arg1.toInt(&bOk);

    if(bOk){
        ui->etDec->setText("Dec: ");
        ui->etDec->setStyleSheet("QLabel { background-color : none; color : black; }");

        QString qsz;

        ui->leBin->setText(qsz.number(n,2));
        ui->leHex->setText(qsz.number(n,16).toUpper());
        ui->leOct->setText(qsz.number(n,8));
    }else{
        if(ui->leDec->hasFocus()){
            ui->etDec->setText("Dec ?");
            ui->etDec->setStyleSheet("QLabel { background-color : yellow; color : red; }");
            ui->leBin->setText(NO_CONVERTIBLE);
            ui->leHex->setText(NO_CONVERTIBLE);
            ui->leOct->setText(NO_CONVERTIBLE);
        }
    }
}

void GinyCanviBase::on_leHex_textChanged(QString q){
    bool bOk;

    int n = q.toInt(&bOk,16);

    if(bOk){
        ui->etHex->setText("Hex: ");
        ui->etHex->setStyleSheet("QLabel { background-color : none; color : black; }");

        QString qsz;

        ui->leBin->setText(qsz.number(n,2));
        ui->leDec->setText(qsz.number(n,10));
        ui->leOct->setText(qsz.number(n,8));
    }else{
        if(ui->leHex->hasFocus()){
            ui->etHex->setText("Hex ?");
            ui->etHex->setStyleSheet("QLabel { background-color : yellow; color : red; }");
            ui->leBin->setText(NO_CONVERTIBLE);
            ui->leDec->setText(NO_CONVERTIBLE);
            ui->leOct->setText(NO_CONVERTIBLE);
        }
    }
}

void GinyCanviBase::on_leOct_textChanged(QString q){
    bool bOk;

    int n = q.toInt(&bOk,8);

    if(bOk){
        ui->etOct->setText("Oct: ");
        ui->etOct->setStyleSheet("QLabel { background-color : none; color : black; }");

        QString qsz;

        ui->leBin->setText(qsz.number(n,2));
        ui->leDec->setText(qsz.number(n,10));
        ui->leHex->setText(qsz.number(n,16).toUpper());
    }else{
        if(ui->leOct->hasFocus()){
            ui->etOct->setText("Oct ?");
            ui->etOct->setStyleSheet("QLabel { background-color : yellow; color : red; }");
            ui->leBin->setText(NO_CONVERTIBLE);
            ui->leDec->setText(NO_CONVERTIBLE);
            ui->leHex->setText(NO_CONVERTIBLE);
        }
    }
}

void GinyCanviBase::on_leBin_textChanged(QString q){
    bool bOk;

    int n = q.toInt(&bOk,2);

    if(bOk){
        ui->etBin->setText("Bin: ");
        ui->etBin->setStyleSheet("QLabel { background-color : none; color : black; }");

        QString qsz;

        ui->leOct->setText(qsz.number(n,8));
        ui->leDec->setText(qsz.number(n,10));
        ui->leHex->setText(qsz.number(n,16).toUpper());
    }else{
        if(ui->leBin->hasFocus()){
            ui->etBin->setText("Bin ?");
            ui->etBin->setStyleSheet("QLabel { background-color : yellow; color : red; }");
            ui->leOct->setText(NO_CONVERTIBLE);
            ui->leDec->setText(NO_CONVERTIBLE);
            ui->leHex->setText(NO_CONVERTIBLE);
        }
    }
}
